﻿//{$WARNINGS OFF}
//=============================================================================
//  文字列中の全角英数字だけを半角の英数字に変換するテストプログラム
//
//-----------------------------------------------------------------------------
//
//  【使用条件等】
//
//  当サイトのアプリケーション類，コンポーネント，コード類は，転載，改変，配布
//  (オリジナル，改変版)などは全て自由です．商用利用も自由です．連絡，使用の記
//  載義務もありません．ただしオリジナルそのものを商用とすることは禁止します．
//  また，配布の際，いかなる理由があろうとも相手に代価を求めることを禁止します．
//  なお，本サイトのプログラムやコードを使用したことによって生じた，いかなる障
//  害，損失に関しても作者は一切関与しないものとします．ご了承下さい．
//
//-----------------------------------------------------------------------------
//
//  【履歴】
//
//  2009年12月12日 ～
//  2013年03月03日 Windows 7 U64(SP1) + Delphi XE Proで動作確認
//
//-----------------------------------------------------------------------------
//
//  【動作確認環境】
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit ToHankakuUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  対象文字列をEdit1にセット
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
begin
  Edit1.Font.Size := 11;
  Edit1.Font.Name := 'ＭＳ ゴシック';
  Edit1.Text      := '你好Ｄｅｌｐｈｉ２０１０안녕하세요叱鮭';

  Edit2.Font.Size := 11;
  Edit2.Font.Name := 'ＭＳ ゴシック';
  Edit2.Text      := '';
end;

//=============================================================================
//  文字列中の全角英数字だけを半角の英数字に変換
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
const
  Dis = $FEE0;
var
  Str   : String;
  i     : Integer;
  AChar : Cardinal;
begin
  Edit2.Text := '';
  Str := '';

  for i := 1 to Length(Edit1.Text) do begin
    AChar := Ord(Edit1.Text[i]);
    if (AChar >= $FF10) and (AChar <= $FF5A) then begin
      Str := Str + Chr(AChar - Dis);
    end else begin
      Str := Str + Edit1.Text[i];
    end;
  end;

  Edit2.Text := Str;
end;

end.
