﻿//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  文字の数値(コードポイント)から文字を取得するChr関数
//
//-----------------------------------------------------------------------------
//
//  【使用条件等】
//
//  当サイトのアプリケーション類，コンポーネント，コード類は，転載，改変，配布
//  (オリジナル，改変版)などは全て自由です．商用利用も自由です．連絡，使用の記
//  載義務もありません．ただしオリジナルそのものを商用とすることは禁止します．
//  なお，本サイトのプログラムやコードを使用したことによって生じた，いかなる障
//  害，損失に関しても作者は一切関与しないものとします．ご了承下さい．
//
//-----------------------------------------------------------------------------
//
//  【履歴】
//
//  2016年05月28日 ～
//
//-----------------------------------------------------------------------------
//
//  【動作確認環境】
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit2: TEdit;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    Edit3: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
  end;

var
  Form1: TForm1;

implementation

uses
  MECSUtils;

{$R *.dfm}

//=============================================================================
//  フォーム生成時の処理
//  コンボボックスにフォント名のリストをセット
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LIndex : Integer;
begin
  //フォント名リストの作成
  ComboBox1.Items.Assign(Screen.Fonts);
  for LIndex := ComboBox1.Items.Count - 1 downto 0 do begin
    //縦書き用フォントは除外
    if Pos('@', ComboBox1.Items[LIndex]) > 0 then begin
      ComboBox1.Items.Delete(LIndex);
    end;
  end;
  LIndex := ComboBox1.Items.IndexOf(Edit2.Font.Name);
  ComboBox1.ItemIndex := LIndex;

  //テスト用の文字コードを文字列でセット
  Edit1.Text := '#$4F60#$20BB7';
end;

//=============================================================================
//  文字の数値(コードポイント)から文字を取得
//  サロゲートペア等,Unicodeの32ビット符号にも対応したコード
//
//  usesにMECSUtilsが必要
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LStrList : TStringList;
  LText    : string;
  LCode    : Cardinal;
  LResText : string;
  LLoopCnt : Integer;
begin
  Edit2.Text := '';

  LStrList := TStringList.Create;
  try
    //デリミタの設定して文字列をセット
    LStrList.Delimiter       := '#';
    LStrList.StrictDelimiter := True;
    LStrList.DelimitedText   := Edit1.Text;

    //1文字分のコードポイントの値を取り出して順番に文字列に追加
    LText := '';
    for LLoopCnt := 0 to LStrList.Count - 1 do begin
      if Trim(LStrList[LLoopCnt]) <> '' then begin
        LText := LText + CodePointToUTF16(StrToInt64(LStrList[LLoopCnt]));
      end;
    end;
  finally
    FreeAndNil(LStrList);
  end;

  //文字のコードポイントを確認表示
  //サロゲートペアに分割されているのを表示
  LResText := '';
  for LLoopCnt := 1 to Length(LText) do begin
    LCode := Ord(LText[LLoopCnt]);
    LResText := LResText + '#$' + IntToHex(LCode, 4);
  end;
  Edit3.Text := LResText;

  Edit2.Text := LText;
end;

//=============================================================================
//  ComboBox1のOnClickイベント
//  コンボボックスでフォント名を選択したらそのフォントで文字を再表示
//=============================================================================
procedure TForm1.ComboBox1Click(Sender: TObject);
begin
  Edit2.Font.Name := ComboBox1.Items[ComboBox1.ItemIndex];
end;

end.
